# -*- coding: utf-8 -*-
"""
/**************************************************************************
        SDATool - A QGIS plugin to do spatial data analysis 
                                using R Statistical package
                             -------------------
    begin                : 2008-01-15
    copyright            : (C) 2008 by Volkan Kepoglu
    email                : vkepoglu at gmail.com
 *************************************************************************/
/**************************************************************************
 *   This program is free software; you can redistribute it and/or modify *
 *   it under the terms of the GNU General Public License as published by *
 *   the Free Software Foundation; either version 2 of the License, or    *
 *   (at your option) any later version.                                  *
 *************************************************************************/
"""
# R options
import sda4ppRoptions
# write to logFile.log
import wl

def doSpatialAnalysis (r, index):
  dt="kstestRpart-doSpatialAnalysis"
  wl.wl("index: " +str(index),dt)
  # to ppp format
  r("v_sp <- as(v_spdf,\"SpatialPoints\")")
  r(str(index["inputFileName"]) + " <- as(v_sp,\"ppp\")")
  textSummary = r("ks <- kstest(" + str(index["inputFileName"]) + ",  covariate=" + str(index["fun"]) + ")")
  # plot
  if index["plot"]:
    rcodes = ["plot(ks, main=\"Kolmogorov-Smirnov Test for " + \
        str(index["inputFileName"]) + "\")"]
    sda4ppRoptions.plotGraphics(r, rcodes)
  return str(textSummary)
